package dummy;

import java.sql.Connection;
import java.sql.SQLException;

import javax.sql.ConnectionEventListener;
import javax.sql.XAConnection;
import javax.transaction.xa.XAResource;

public class ProxyXAConnection implements XAConnection {

	final XAConnection del;
	Connection con;
	XAResource xares;
	
	ProxyXAConnection(XAConnection con) {
		this.del = con;
	}
	
	public XAResource getXAResource() throws SQLException {
		log("getXAResource");
		if( xares == null ) {
			xares = new ProxyXAResource(del.getXAResource());
		}
		return xares;
	}

	public void addConnectionEventListener(ConnectionEventListener arg0) {
		del.addConnectionEventListener(arg0);
	}

	public void close() throws SQLException {
		log("close");
		del.close();
	}

	public Connection getConnection() throws SQLException {
		log("getConnection");
		return del.getConnection();
	}

	public void removeConnectionEventListener(ConnectionEventListener arg0) {
		del.removeConnectionEventListener(arg0);
	}
	
	private void log(String msg) {
		//System.out.println("##### XAConnection ["+System.identityHashCode(del)+"] "+msg);
		/*Exception exc = new Exception();
		exc.printStackTrace();*/
	}	

}
