package dummy;

import javax.transaction.xa.XAException;
import javax.transaction.xa.XAResource;
import javax.transaction.xa.Xid;

public class ProxyXAResource implements XAResource {

	XAResource del;
	
	ProxyXAResource(XAResource xares) {
		this.del = xares;
	}
	
	public void commit(Xid arg0, boolean arg1) throws XAException {
		log("commit "+arg1, arg0);
		del.commit(arg0, arg1);
	}

	public void end(Xid arg0, int arg1) throws XAException {
		log("end "+arg1, arg0);
		del.end(arg0, arg1);
	}

	public void forget(Xid arg0) throws XAException {
		log("forget ",arg0);
		del.forget(arg0);
	}

	public int getTransactionTimeout() throws XAException {
		return del.getTransactionTimeout();
	}

	public boolean isSameRM(XAResource arg0) throws XAException {
		return del.isSameRM(arg0);
	}

	public int prepare(Xid arg0) throws XAException {
		int i = del.prepare(arg0);
		log("prepare result: "+i, arg0);
		return i;
	}

	public Xid[] recover(int arg0) throws XAException {
		return del.recover(arg0);
	}

	public void rollback(Xid arg0) throws XAException {
		log("rollback ",arg0);
		del.rollback(arg0);
	}

	public boolean setTransactionTimeout(int arg0) throws XAException {
		return del.setTransactionTimeout(arg0);
	}

	public void start(Xid arg0, int arg1) throws XAException {
		log("start "+arg1, arg0);
		del.start(arg0, arg1);
	}
	
	private void log(String msg, Xid xid) {
		System.out.println("##### XAResource ["+System.identityHashCode(del)+"] "+msg+"; "+toString(xid));
		Exception exc = new Exception();
		exc.printStackTrace();
	}
	
	private static String toString(Xid xid) {
		byte[] globalid = xid.getGlobalTransactionId();
		byte[] branch = xid.getBranchQualifier();
		int format = xid.getFormatId();
		StringBuilder sb = new StringBuilder();
		sb.append(format).append(":");
		for( int i=0; i<globalid.length; i++) {
			sb.append(globalid[i]);
		}
		sb.append("; branch: ");
		for( int i=0; i<branch.length; i++) {
			sb.append(branch[i]);
		}		
		return sb.toString();
	}

}
